# -*- coding:Utf-8 -*-
"""
    Gère un décompte écrit et audio de la bombe sous Counter-Strike: Source
"""

import psyco
psyco.full()

import es, usermsg, os, popuplib
from Decompte import Decompte


info = es.AddonInfo()
info.name = "Complete C4Timer"
info.version = "2.2"
info.author = "Nicolous"
info.url = "http://mattie.info/forums/"
info.description = "Provide a C4 countdown"
info.tags = "c4;countdown"

CONFIGURATION_FILE = "addons/eventscripts/complete_c4timer/configuration.txt"
CWD = os.getcwd()

# ConVar publique pour tracer le script sur les moniteurs de serveurs
c4timer_version = es.ServerVar("c4timer_version",info.version).makepublic()

c4timer_activation = es.ServerVar("c4timer_activation","0","C4Timer : 1 = activation, 0 = off")
c4timer_sound_dir = es.ServerVar("c4timer_sound_dir","c4timer","C4Timer : sounds localization from cstrike/sound")
c4timer_chat_countdown = es.ServerVar("c4timer_chat_countdown","0","C4Timer : 1 = chat countdown, 0 = off")
c4timer_hud_countdown = es.ServerVar("c4timer_hud_countdown","0","C4Timer : 1 = hud countdown, 0 = off")
c4timer_center_countdown = es.ServerVar("c4timer_center_countdown","0","C4Timer : 1 = center countdown, 0 = off")
c4timer_amx_countdown = es.ServerVar("c4timer_amx_countdown","0","C4Timer : 1 = amx countdown, 0 = off")
c4timer_sound_countdown = es.ServerVar("c4timer_sound_countdown","0","C4Timer : 1 = sound countdown, 0 = off")

# Récupération d'une référence sur la ConVar mp_c4timer du jeu
mp_c4timer = es.ServerVar("mp_c4timer")

# Instanciation de notre "décompteur"
decompte = Decompte()

def planifieTelechargements():
    """Planifie de façon dynamique les sons à faire télécharger aux joueurs"""

    if int(c4timer_sound_countdown) and int(mp_c4timer) >= 0:
        index = int(mp_c4timer)
        # Bien que la ConVar soit bornée, un es_forcevalue peut forcer une valeur incohérente (par exemple)
        if index < 0:
            index = 0
        # Pour chaque seconde possible du décompte...
        # format : c4timer_<SECONDE>_sec.mp3
        while index >= 0:
            # ... On regarde s'il existe un fichier son correspondant
            nomMod = "sound/%s/c4timer_%s_sec.mp3" % (str(c4timer_sound_dir),str(index))
            nom =  "%s/cstrike/%s" % (CWD,nomMod)
            if os.path.isfile(nom):
                # Si oui, on l'ajoute aux téléchargements requis pour entrer sur le serveur
                es.stringtable("downloadables",nomMod)
            index -= 1


def executeConfig():
    """Exécute la configuration du script"""

    if os.path.isfile("%s/cstrike/%s" % (CWD,CONFIGURATION_FILE)):
        es.server.cmd("es_xmexec ../%s" % CONFIGURATION_FILE)
    else:
        es.dbgmsg(0,"Unable to find %s !" % CONFIGURATION_FILE)

    # Planification automatique des téléchargements
    planifieTelechargements()
    

def affiche(tempsRestant):
    """Affiche le décompte"""

    # Si le décompte n'est plus activé on l'arrête
    if int(c4timer_activation):
        
        userlist = es.getUseridList()
        tempsRestantStr = str(tempsRestant)
        nomMod = "%s/c4timer_%s_sec.mp3" % (str(c4timer_sound_dir),tempsRestantStr)
        nomSon = "%s/cstrike/sound/%s" % (CWD,nomMod)
        commande = "play %s"  % (nomMod)

        for userid in userlist:  
            # Affichage dans le TCHAT
            if int(c4timer_chat_countdown):
                es.tell(userid,"#green",tempsRestantStr)

            # Affichage dans le HUD centré
            if int(c4timer_hud_countdown):
                usermsg.hudhint(userid,tempsRestantStr)

            # Affichage centré
            if int(c4timer_center_countdown):
                es.centertell(userid,tempsRestantStr)

            # Affichage dans un popup
            if int(c4timer_amx_countdown):
                popup = popuplib.create("C4CountDown%s" % userid)
                popup.timeout("view",1)
                popup.timeout("send",1)
                popup.addline(tempsRestantStr)
                popup.send(userid)
                    
            # Lecture du son correspondant
            if int(c4timer_sound_countdown):
                if os.path.isfile(nomSon):
                    es.cexec(userid,commande)
    else:
        decompte.stoppeDecompte()


def es_map_start(event_var):
    executeConfig()


def bomb_planted(event_var):
    if int(c4timer_activation):
        duree = int(mp_c4timer)
        if duree <= 0:
            duree = 0
        decompte.lanceDecompte(duree,affiche)


def bomb_defused(event_var):
    decompte.stoppeDecompte()


def round_end(event_var):
    # Arrêt du décompte si l'origine de la fin du round n'est pas l'explosion de la bombe
    if event_var["message"] != "#Target_Bombed":
        decompte.stoppeDecompte()


def round_start(event_var):
    decompte.stoppeDecompte()
